searchNodes=[{"doc":"A function decorator for OpenTelemetry traces.InstallationAdd open_telemetry_decorator to your list of dependencies in mix.exs. We include the opentelemetry_api package, but you'll need to add opentelemetry yourself in order to report spans and traces.def deps do [ {:open_telemetry_decorator, &quot;~&gt; 0.4.0&quot;}, {:opentelemetry, &quot;~&gt; 0.4.0&quot;} ] endThen follow the directions for the exporter of your choice to send traces to to zipkin, honeycomb, etc.https://github.com/garthk/opentelemetry_honeycombhttps://github.com/opentelemetry-beam/opentelemetry_zipkinUsageAdd use OpenTelemetryDecorator to the module, and decorate any methods you want to trace with @decorate trace(&quot;span name&quot;) or @decorate simple_trace(&quot;span name&quot;).The simple_trace decorator will automatically add your input parameters and the function result to the span attributes. If you omit the span name, one will be generated based on the module, function, and arity. Specifying a name is helpful for handle_info type functions where the name/arity would be ambiguous.defmodule MyApp.Worker do use OpenTelemetryDecorator @decorate simple_trace() # Generates span name &quot;MyApp.Worker.do_work/2&quot;. or... @decorate simple_trace(&quot;worker.do_work&quot;) def do_work(arg1, arg2) do ...doing work end endThe trace decorator allows you to specify an includes option which gives you more flexibility with what you can include in the span attributes. Omitting the includes option with trace means no attributes will be added to the span.defmodule MyApp.Worker do use OpenTelemetryDecorator @decorate trace(&quot;worker.do_work&quot;, include: [:arg1, :arg2]) def do_work(arg1, arg2) do ...doing work end endThe decorator uses a macro to insert code into your function at compile time to wrap the body in a new span and link it to the currently active span. In the example above, the do_work method would become something like this:def do_work(arg1, arg2) do require OpenTelemetry.Span require OpenTelemetry.Tracer parent_ctx = OpenTelemetry.Tracer.current_span_ctx() OpenTelemetry.Tracer.with_span &quot;my_app.worker.do_work&quot;, %{parent: parent_ctx} do OpenTelemetry.Span.set_attributes(arg1: arg1, arg2: arg2) ...doing work end endYou can provide span attributes by specifying a list of variable names as atoms.This list can include...Any variables (in the top level closure) available when the function exits:defmodule MyApp.Math do use OpenTelemetryDecorator @decorate trace(&quot;my_app.math.add&quot;, include: [:a, :b, :sum]) def add(a, b) do sum = a + b {:ok, thing1} end endThe result of the function by including the atom :result:defmodule MyApp.Math do use OpenTelemetryDecorator @decorate trace(&quot;my_app.math.add&quot;, include: [:result]) def add(a, b) do sum = a + b {:ok, thing1} end endMap/struct properties using nested lists of atoms:defmodule MyApp.Worker do use OpenTelemetryDecorator @decorate trace(&quot;my_app.worker.do_work&quot;, include: [[:arg1, :count], [:arg2, :count], :total]) def do_work(arg1, arg2) do total = arg1.count + arg2.count {:ok, total} end end","ref":"OpenTelemetryDecorator.html","title":"OpenTelemetryDecorator","type":"module"},{"doc":"","ref":"OpenTelemetryDecorator.html#simple_trace/0","title":"OpenTelemetryDecorator.simple_trace/0","type":"macro"},{"doc":"","ref":"OpenTelemetryDecorator.html#simple_trace/1","title":"OpenTelemetryDecorator.simple_trace/1","type":"macro"},{"doc":"Decorate a function to add an OpenTelemetry trace with a named span. The input parameters and result are automatically added to the span attributes. You can specify a span name or one will be generated based on the module name, function name, and arity.defmodule MyApp.Worker do use OpenTelemetryDecorator @decorate simple_trace() def do_work(arg1, arg2) do total = arg1.count + arg2.count {:ok, total} end @decorate simple_trace(&quot;worker.do_more_work&quot;) def handle_call({:do_more_work, args}, _from, state) do {:reply, {:ok, args}, state} end end","ref":"OpenTelemetryDecorator.html#simple_trace/2","title":"OpenTelemetryDecorator.simple_trace/2","type":"function"},{"doc":"","ref":"OpenTelemetryDecorator.html#simple_trace/3","title":"OpenTelemetryDecorator.simple_trace/3","type":"function"},{"doc":"","ref":"OpenTelemetryDecorator.html#trace/1","title":"OpenTelemetryDecorator.trace/1","type":"macro"},{"doc":"","ref":"OpenTelemetryDecorator.html#trace/2","title":"OpenTelemetryDecorator.trace/2","type":"macro"},{"doc":"Decorate a function to add an OpenTelemetry trace with a named span. You can provide span attributes by specifying a list of variable names as atoms.This list can include:any variables (in the top level closure) available when the function exits,the result of the function by including the atom :result,map/struct properties using nested lists of atoms.defmodule MyApp.Worker do use OpenTelemetryDecorator @decorate trace(&quot;my_app.worker.do_work&quot;, include: [:arg1, [:arg2, :count], :total, :result]) def do_work(arg1, arg2) do total = arg1.count + arg2.count {:ok, total} end end","ref":"OpenTelemetryDecorator.html#trace/4","title":"OpenTelemetryDecorator.trace/4","type":"function"}]